"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _factory = require("./variate/factory");

var _factory2 = _interopRequireDefault(_factory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Variate = function () {
  function Variate() {
    _classCallCheck(this, Variate);
  }

  _createClass(Variate, [{
    key: "init",
    value: function init() {
      this.state({ client: typeof document != "undefined" });
    }
  }, {
    key: "convert",
    value: function convert(_ref) {
      var cookie = _ref.include.cookie;
      var chain = _ref.promise.chain;
      var client = _ref.state.client;

      if (!client) {
        return;
      }

      return chain(this.getTest, cookie().read, this.throwUnlessVariant, this.setConverted, cookie().read, this.convertUnlessVariant);
    }
  }, {
    key: "getTest",
    value: function getTest(_ref2) {
      var name = _ref2.name;
      var tests = _ref2.state.tests;

      var test = tests[name];

      if (!test) {
        throw new Error("test not found");
      }

      return { test: test };
    }
  }, {
    key: "randomVariant",
    value: function randomVariant(_ref3) {
      var test = _ref3.test;
      var client = _ref3.state.client;

      var index = Math.random() * test.length;
      index = Math.floor(index);

      if (!client) {
        index = 0;
      }

      return { variant: test[index] };
    }
  }, {
    key: "returnVariant",
    value: function returnVariant(_ref4) {
      var variant = _ref4.variant;

      return variant;
    }
  }, {
    key: "convertUnlessVariant",
    value: function convertUnlessVariant(_ref5) {
      var variant = _ref5.variant;
      var cookie = _ref5.include.cookie;
      var chain = _ref5.promise.chain;
      var callback = _ref5.state.callback;

      if (!variant) {
        return chain(this.unsetConverted, cookie().read, this.setConverted, callback, cookie().write);
      }
    }
  }, {
    key: "setConverted",
    value: function setConverted() {
      return { converted: true };
    }
  }, {
    key: "test",
    value: function test(_ref6) {
      var cookie = _ref6.include.cookie;
      var chain = _ref6.promise.chain;

      return chain(this.getTest, cookie().read, this.testUnlessVariant);
    }
  }, {
    key: "testUnlessVariant",
    value: function testUnlessVariant(_ref7) {
      var variant = _ref7.variant;
      var chain = _ref7.promise.chain;
      var callback = _ref7.state.callback;

      if (variant) {
        return chain(this.returnVariant);
      } else {
        return chain(this.writeVariant, callback, this.returnVariant);
      }
    }
  }, {
    key: "throwUnlessVariant",
    value: function throwUnlessVariant(_ref8) {
      var variant = _ref8.variant;

      if (!variant) {
        throw new Error("convert() called before test()");
      } else {
        return {};
      }
    }
  }, {
    key: "unsetConverted",
    value: function unsetConverted() {
      return { converted: false };
    }
  }, {
    key: "updated",
    value: function updated(_ref9) {
      var state = _ref9.state;
      var cookie = _ref9.include.cookie;

      cookie(state);
    }
  }, {
    key: "writeVariant",
    value: function writeVariant(_ref10) {
      var variant = _ref10.variant;
      var cookie = _ref10.include.cookie;
      var chain = _ref10.promise.chain;

      if (!variant) {
        return chain(this.randomVariant, cookie().write);
      }
    }
  }]);

  return Variate;
}();

exports.default = (0, _factory2.default)(Variate);
//# sourceMappingURL=variate.js.map